                                                                            
; HEWO.ASM: HELLO WORLD + IDMR                                             

	list		p=16f1827      
	list		r=dec
	#include	<p16f1827.inc> 

; Konfigurci (2 sz)
    __CONFIG _CONFIG1, _FOSC_HS & _WDTE_OFF & _PWRTE_ON & _MCLRE_OFF & _CP_OFF & _CPD_OFF & _BOREN_OFF & _CLKOUTEN_OFF & _IESO_OFF & _FCMEN_OFF
    __CONFIG _CONFIG2, _WRT_OFF & _PLLEN_OFF & _STVREN_OFF & _BORV_19 & _LVP_OFF

; Vltozk
	CBLOCK	0X20
	lcb1:16
	lcb2:16
	hossz
	fmask
	vezer
	tflag
	ms1
	ms10
	ms100
	sec1
	sec10
	min1
	min10
	hr1
	ENDC
    CBLOCK 0x70 ; Define GPR variable register locations
    lcd
    count
    index
    chars
    posi
    flags
    base 
    dpage
    ENDC
    CBLOCK 0XA0
    lcb1a:16
    lcb2a:16
    ENDC
	    
line1	equ	0x80
line2	equ	0xc0

#define	merhet	fmask,3	
#define	kiir0	fmask,0
#define	kiir2	tflag,6
#define	kiir1	tflag,5
#define	torol0	tflag,4
#define	clr1	tflag,3
#define	car	flags,7
#define	cgram	flags,5
#define	rovid	flags,4
#define	flag	flags,0
#define	lcdport	portb
#DEFINE	RS	PORTA,1
#DEFINE	E	PORTA,2
  
	#include	<prlx.inc>	; Parallax makrogyjtemny
			
    org     0x0000            
    pagesel start
    goto    start             

;Megszakts

	org     4
	movlp	0
	movlb	0
	comf	portb,w
	andlw	0xf0	; b fels negltja
	movwf	vezer
	andlw	0x30	; b4-b5
	jz	hiba
	btfss	vezer,5
	goto	bal
	btfss	vezer,4
	goto	jobb
	jb	merhet,skin
	call	mbp011
	bsf	merhet
	bsf	kiir0
	bsf	kiir2
	goto	rest
hiba
jobb
bal
	jnb	merhet,rest
	bcf	merhet
	bcf	kiir0
	movlw	lcb1
	movwf	fsr0l
	call	movbuf
	bsf	kiir1
	bsf	torol0
	goto	rest
skin
	call	ora
rest
	movlw	lcb1
	movwf	fsr0l
	jnb	kiir1,skki0
	btfsc	kiir0
	call	movbuf
skki0
	bsf	kiir1
	call	clrora
	bcf	pir1,tmr2if
	retfie

start	
 	banksel	lata
	movlw	0x0		; a porton minden 0
	movwf	lata
	movlw	0x0		; b porton is 
	movwf	latb
	banksel	pir1
	clrf	pir1
	movlw	249		; timer2 peridus (4m/4/250/4=1 khz)
	movwf	pr2
	movlw	1		; 
	movwf	t2con		; eloszt 4	
	banksel	trisa
	movlw	8
	movwf	option_reg
	movlw	0x68		; 16 mhz=78, 4 mhz=68, 8 mhz=70
	movwf	osccon
	bsf	pie1,tmr2ie	; ez lesz az egyik engedlyezett megszakts
	movlw	0x00		; mind kimenet 0 rtkkel
	movwf	trisa
	movlw	0xf0
	movwf	trisb		; b port ilyen
	banksel	wpub
	movl	wpua,0x20	; de nincs is felhz az a porton!
	movl	wpub,0xf0	; fels 4-en lesz bels felhz
	banksel	ansela
	clrf	ansela
	clrf	anselb
	banksel	porta
	clrf	flags
	bsf	intcon,peie
	bsf	intcon,gie	; ezzel beengedem a tmr2 megszaktst (s semmi mst)
	call	dini
	call	mdelay
	movl	posi,0x40	; kezetesek tltse
	movl	dpage,high chgen
	movl	base, low chgen
	movl	chars,16	; csak 2 privt karakter
	bsf	cgram		; a nulla nem vgjel
	call	dispt
	bcf	cgram
	call	mdelay
	banksel	porta
	clrf	fsr1h
	movl	dpage,high text1
	movl	base,low text1
	call	dt161
	call	mdelay
	movl	base,low text2
	call	dt162
	call	ldelay
	call	ldelay
	call	ldelay
	call	ldelay
	call	ldelay
	call	ldelay
	call	ldelay
	call	ldelay
	call	ldelay
	call	ldelay
	call	ldelay
	call	ldelay
	call	ldelay
	call	ldelay
	call	ldelay
	clrf	vezer
	clrf	tflag
	clrf	flags
	bsf	t2con,tmr2on	; ra indul
	call	bufini		; lcb1-be csupa space
	movl	base,low text3
	call	gt161		; ha a dt161 mkdne, idmaszk jnne.
	call	dv1611
	movl	fsr0l,lcb2
	call	bfini		; pmt is eltnik
	call	mdelay
	call	dv1622
	call	mdelay
	call	mbp011
	bsf	torol0
	movl	fsr0l,lcb2
	call	mbp01
malo
	jnb	clr1,skc
	bcf	clr1
	movl	base,low text4
	call	dt161
	call	mdelay
skc
	jnb	kiir1,skk1
	bcf	kiir1
	movl	fsr1l,lcb1
	movl	chars,11
	movl	posi,line1
	call	dispv
	call	mdelay
skk1
	jnb	kiir2,skk2
	bcf	kiir2
	movl	fsr1l,lcb1a
	call	dv162
	call	mdelay
skk2
	goto	malo
	
; lcb1-bl a htterbe ill. brhonnan a htterbe teljes sort	
mbp011
	movlw	lcb1
mbp01
	movwf	fsr0l
	movlw	16
	btfsc	rovid
	movlw	11
	movwf	count
atrak
	movf	indf0,w
	bsf	fsr0l,7
	movwi	fsr0++
	bcf	fsr0l,7
	djnz	count,atrak
	return
; rbl az fsr0 ltal cmzett kijelz pufferbe, kettspontokkal 	
movbuf
	movf	hr1,w
	movwi	fsr0++
	movlw	':'
	movwi	fsr0++
	movf	min10,w
	movwi	fsr0++
	movf	min1,w
	movwi	fsr0++
	movlw	':'
	movwi	fsr0++
	movf	sec10,w
	movwi	fsr0++
	movf	sec1,w
	movwi	fsr0++
	movlw	':'
	movwi	fsr0++
	movf	ms100,w
	movwi	fsr0++
	movf	ms10,w
	movwi	fsr0++
	movf	ms1,w
	movwi	fsr0++
	return
	
bufini
	movl	fsr0l,lcb1
bfini
	movl	chars,16
	movlw	0x20
bilp
	movwi	fsr0++
	djnz	chars,bilp
	return
	
ora
	btfss	merhet
	return
	incf	ms1,f
	cjnel	ms1,0x3a,endora
	movl	ms1,0x30
	incf	ms10,f
	cjnel	ms10,0x3a,endora
	movl	ms10,0x30
	incf	ms100,f
	btfsc	kiir0
	bsf	kiir1
	cjnel	ms100,0x3a,endora
	movl	ms100,0x30
	incf	sec1,f
	cjnel	sec1,0x3a,endora
	movl	sec1,0x30
	incf	sec10,f
	cjnel	sec10,0x36,endora
	movl	sec10,0x30
	incf	min1,f
	cjnel	min1,0x3a,endora
	movl	min1,0x30
	incf	min10,f
	cjnel	min10,0x36,endora
	movl	min10,0x30
	incf	hr1,f
endora
	return
; a kvetkez szubrutin csak a szmllt nullzza, a kijelz
; pufferben s a kijelzn az rtk nem vltozik!
clrora
	btfss	torol0
	return
	movlw	0x30
	movwf	hr1
	movwf	min10
	movwf	min1
	movwf	sec10
	movwf	sec1
	movwf	ms100
	movwf	ms10
	movwf	ms1	
	bcf	torol0
	return
			
	#INCLUDE <LCD.INC>

	org	0x300
text1	dt	' ',' ','H','E','L','L','O',' ','W','O','R','L','D','!',' ',' '
text2	dt	' ',' ','P',1,'G',' ','M','O',' ','T','H',1,'I','N',' ',' '
text3	dt	'0',':','0','0',':','0','0',':','0','0','0',' ',' ',' ',' ',' '	
text4	dt	' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' '	
chgen   dt	' ',' ',' ',' ',' ',' ',' ',' '
	dt	2,4,14,17,17,17,14,0
	
	END