; LCD.INC: kijelzkezels, bvtett magra

; pozcionls
DPOS
	BCF	FLAG
	MOV	LCD,POSI
	GOTO	DISP
; egy indirekt cmzs karakter kirsa cmnvelssel
DIND
	MOVIW	FSR1++	; elszr W-be kerl,
DWREG			; aztn tveszi a W kir
	MOVWF	LCD
	BSF	FLAG
	INCF	POSI,F
	GOTO	DISP
; szmjegy kirsa egy bjt als 4 bitjrl cmnvelssel
DINUM
	MOVIW	FSR1++	; szintn W-n keresztl
DIW	
	ANDLW	15
	IORLW	48
	GOTO	DWREG
; RAM kir csald
DV1622				; 2. puffert a 2. sorba
	MOVL	FSR1L,LCB2
DV162				; brhonnan (fsr1 cmzi) 16 karaktert
	MOVL	POSI,LINE2	; a 2. sorba
	GOTO	DV16
DV1611				; 1. puffert az 1. sorba
	MOVL	FSR1L,LCB1
DV161
	MOVL	POSI,LINE1
DV16
	MOVL	CHARS,16	; 16 karaktert 
DISPV
	CALL	DPOS
	CALL	DELAY
DVNXT
	CALL	DIND
	DJNZ	CHARS,DVNXT
	RETURN
; tmrtetlen BCD kirs	
DISPN
	CALL	DPOS
DNNXT
	CALL	DINUM
	DJNZ	CHARS,DNNXT
	RETURN
; jobbra tmrtett BCD kirs
DISPN2
	CALL	DPOS
DN2NXT
	CALL	DINUMH
	CALL	DINUM
	DJNZ	CHARS,DN2NXT
	RETURN
DINUMH				; a bjt fels 4 bitje
	SWAPF	INDF1,W
	GOTO	DIW
; programmemriban trolt szveg kirsa
DT161
	MOVL	POSI,LINE1
	GOTO	DT16
DT162
	MOVL	POSI,LINE2
DT16
	MOVL	CHARS,16
DISPT
	CALL	DPOS
	BANKSEL	HOSSZ
	MOV	HOSSZ,CHARS
DTNXT
	BSF	FLAG
	MOV	PCLATH,DPAGE
	BANKSEL	HOSSZ
	MOVF	CHARS,W
	SUBWF	HOSSZ,W
	ADDWF	BASE,W
	CALLW
	MOVWF	LCD
	PAGESEL	DISPT	
	MOVF	LCD,W
	CALL	DWREG
	DJNZ	CHARS,DTNXT
	RETURN
; szveg mozgatsa programtrbl pufferbe
GT161
	MOVL	FSR1L,LCB1
	GOTO	GT16
GT162
	MOVL	FSR1L,LCB2
GT16
	MOVL	CHARS,16
	BANKSEL	HOSSZ
GETT	MOV	HOSSZ,CHARS
GTNXT
	MOV	PCLATH,DPAGE
	MOVF	CHARS,W
	SUBWF	HOSSZ,W
	ADDWF	BASE,W
	CALLW
	MOVWI	FSR1++
	CLRF	PCLATH
	DJNZ	CHARS,GTNXT
	RETURN
;ksleltetsek
DELAY	
	MOVL	INDEX,1
	MOVL	COUNT,31
DL
	DJNZ	COUNT,DL
	DJNZ	INDEX,DL
	RETURN
MDELAY
	MOVL	INDEX,5
	CLRF	COUNT
	GOTO	DL
LDELAY
	MOVL	INDEX,255
	CLRF	COUNT
	GOTO	DL
; kir alaprutin
DISP
	BANKSEL	LATA
	SNB	FLAG
	BSF	RS
	ANDL	LCDPORT,0XF0
	SWAPF	LCD,W
	ANDLW	15
	IORWF	LCDPORT,F
	NOP
	BSF	E
	NOP
	BCF	E
	ANDL	LCDPORT,0XF0
	MOVF	LCD,W
	ANDLW	15
	IORWF	LCDPORT,F
	NOP
	BSF	E
	NOP
	BCF	E
	MOVLW	0XF0
	ANDWF	LCDPORT,F
	NOP	
	BCF	RS
	BANKSEL	PORTB
	BCF	FLAG
	GOTO	DELAY
; incializls, 1. rsz
DINI
	CALL	LDELAY
	MOVL	LCDPORT,B'00000011'
	BSF	E
	NOP
	NOP
	BCF	E
	CALL	LDELAY
	MOVL	LCDPORT,B'00000011'
	BSF	E
	NOP
	NOP
	BCF	E
	CALL	MDELAY
	MOVL	LCDPORT,B'00000011'
	BSF	E
	NOP
	NOP
	BCF	E
	CALL	DELAY
; incializls, 2. rsz
DINI1
	BCF	FLAG
	MOVL	LCD,B'00101100'
	CALL	DISP
	MOVL	LCD,B'00001100'
	CALL	DISP
	MOVL	LCD,B'00000110'
	CALL	DISP
	MOVL	LCD,B'00000001'
	CALL	DISP
	RETURN









